/* 
 * JBoss, Home of Professional Open Source
 * Copyright 2012 Red Hat Inc. and/or its affiliates and other contributors
 * as indicated by the @authors tag. All rights reserved.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */

package distributed.annotation.processor;

import java.lang.annotation.Annotation;

import distributed.annotation.SetUp;


/**
 * @author Seiya Kawashima <skawashima@uchicago.edu>
 */
public class SetUpProcessor extends AbstractProcessor {

	public SetUpProcessor(Object target){
		super(target);
	}
	
	/* (non-Javadoc)
	 * @see mapreduce.annotation.processor.Processor#process()
	 */
	public Object[] process() {
		
		Annotation an = validate(SetUp.class);
		if(an == null){
			return null;
		}
		SetUp setUp = (SetUp)an;
		Object[] values = new Object[6];
		values[0] = setUp.numberOfMap();
		values[1] = setUp.numberOfReduce();
		values[2] = setUp.maxTrial();
		values[3] = setUp.slaves();
		values[4] = setUp.slaveList();
		values[5] = setUp.recordFormat();
		
		return values;
	}

}
